# vim: set sw=4 ts=4 si et:
# Written by: Guido Socher, Copyright: GPL

# common and configuration parts fo lfwmail
package lfwmC;

sub getconfig(){
    my %cfdat;
    #---------------- start configuration, you may change this:
    # the url of the lfwmail program:
    $cfdat{'url'}='http://yourserver.org/cgi-bin/lfwmail';
    #
    # There should not be read access for normal users on 
    # $secretsdir since we store cookies and passwords there. 
    # So chmod 700 and chown apache is probably what you want to run.
    $cfdat{'secretsdir'}='/home/lfwmail/sec';
    #
    # temporary directory for mime messages. Must be writable for the
    # process id under which your webserver runs (probably: chown apache).
    $cfdat{'mimetmpdir'}='/home/lfwmail/tmp';
    #
    # how to convert html to plain text (/usr/bin/lynx -dump or /usr/bin/w3m -dump):
    $cfdat{'htmldecoder'}='/usr/bin/w3m -dump';
    #
    # where to connect to via pop3. localhost should be correct for
    # most of the cases:
    $cfdat{'pophost'}="localhost";
    #
    # domain name to use when sending (The stuff after the @ in the email):
    $cfdat{'domain'}="yourserver.org";
    #
    # shadow users (string to delete from uid before sending, this is a regexp,
    # this is a security feature. e-mail address and pop login can be different
    # by using this.):
    $cfdat{'shadowuid'}='_wm$';
    #---------------- end configuration, you may change this:
    return(\%cfdat);
}
#------------- common functions
sub version(){
    '0.6';
}
# escape certain html characters:
sub htmlescape($){
    my $str=shift;
    $str=~s/&/&amp;/g;
    $str=~s/</&lt;/g;
    $str=~s/"/&quot;/g;
    $str=~s/>/&gt;/g;
    $str;
}
sub getACU($){
    my $q=shift; # CGI query pointer
    my %d;
    $d{'action'}=$q->param('a');
    $d{'cookie'}=$q->param('c');
    $d{'uid'}=$q->param('uid');
    #security cleanup:
    $d{'uid'}=~s/[^\w\.\-\%]+//g if ($uid);
    $d{'cookie'}=~s/\W//g if ($cookie);
    $d{'action'}=~s/\W//g if ($action);
    return(\%d);
}
#
# print error messages in html:
sub htmldie_noheader($$){
    my $q=shift; # CGI query pointer
    my $msg=shift;
    print "<p>$msg</p>\n";
    print $q->end_html;
    print "\n";
    exit 0;
}
sub htmldie($$){
    my $q=shift; # CGI query pointer
    my $msg=shift;
    print $q->header(-Pragma=> 'no-cache',-type=>'text/html');
    print $q->start_html(-title=>"lfwmail web mail");
    htmldie_noheader($q,$msg);
}
# like htmldie but add a standard sentence:
sub htmldie_std($$){
    my $q=shift; # CGI query pointer
    my $msg=shift;
    my $cf=getconfig();
    my $url=$cf->{'url'};
    my $errstr=' Click below to restart<br><a href="'. $url .'?new" target="_top">'. $url ."</a>";
    htmldie($q,$msg . $errstr);
}
# translate a cookie into password using the session file
sub cookie2pw($$$){
    my $q=shift; # CGI query pointer
    my $cook=shift;
    my $uid=shift;
    my $pw;
    my $cf=getconfig();
    my $tmp;
    my $browserid="";
    my @ldat;

    if (-f $cf->{'secretsdir'}."/$uid.session"){
        # not more than 0.5 days old
        if ((-M $cf->{'secretsdir'}."/$uid.session") < 0.5){
            $tmp=$q->user_agent()||'unknown_agent';
            $tmp=~s/[^\w\. ]+/ /g;
            $browserid=$tmp;
            $tmp=$ENV{'REMOTE_ADDR'}||'0.0.0.0';
            $tmp=~s/[:;]//g;
            $browserid.=",".$tmp;
            $pw=undef;
            open(FF,$cf->{'secretsdir'}."/$uid.session")||die "ERROR: can not read ".$cf->{'secretsdir'}."$uid.session, effective uid=$>\n";
            while(<FF>){
                if (/\w/){
                    chomp;
                    @ldat=split(/:/,$_,2);
                    if ($ldat[0] && $ldat[1] && ($ldat[0] eq "${uid};${cook};${browserid}")){
                        $pw=$ldat[1];
                    }
                }
            }
            close FF;
            return($pw) if ($pw);
            # everything else is error:
            htmldie_std($q,"Session data invalid, wrong id.");
        }else{
            # delete old
            unlink($cf->{'secretsdir'}."/$uid.session");
        }
        htmldie_std($q,"Session too old.");
    }
    htmldie_std($q,"No active session found.");
}

1;

